:REM  UKAW.BAT ͻ
:REM                                                                       
:REM  Funktion: Aufbau einer PPP-Verbindung und Ausfhren der externen     
:REM            UKAW-Clients mit CrossPoint/OpenXP v3.40 in einer DOS-Box  
:REM            von Windows 9x/ME, 2000/NT/XP                              
:REM                                                                       
:REM  Version : v0.42/2.75 vom 22.09.2001 ('work in progress')             
:REM                                                                       
:REM  Autor   : Michael Heydekamp                                          
:REM            eMail:  <my@openxp.de>                                     
:REM                    <michael.heydekamp@t-online.de>                    
:REM            WWW:     http://www.openxp.de/                             
:REM                                                                       
:REM  Credits : Horst Schaeffer fr seine Batch-Utilities ASCREEN, LMOD,   
:REM            QECHO, VARGET, VARSET, WAIT und WBAT. Ohne diese Freeware- 
:REM            Utilities wre die Realisierung dieses Kits nicht mglich  
:REM            gewesen.                                                   
:REM            eMail:  <horst.schaeffer@gmx.net>                          
:REM            WWW:    http://home.mnet-online.de/horst.muc/              
:REM                                                                       
:REM            Robert Pirko (in memoriam) fr sein geniales und ultra-    
:REM            schnelles Sort-Utility RPSORT, das selbst extrem groe     
:REM            Textdateien auch auf langsameren Rechnern in Bruchteilen   
:REM            von Sekunden sortieren und doppelte Eintrge eliminieren   
:REM            kann. RPSORT wird in diesem Kit fr die Sortierung der     
:REM            Newsgroup-Listen (*.BL) und der Listen der bestellten      
:REM            Newsgroups (*.RC) eingesetzt.                              
:REM                                                                       
:REM            Alle Utilities befinden sich in der zur Laufzeit von       
:REM            UKAW.BAT aus CLNT-CFG.EXE extrahierten Datei $DO.COM. Dank 
:REM            an die Autoren fr die Erlaubnis, die Utilities zu verwen- 
:REM            den und mit diesem Client-Kit fr OpenXP auszuliefern.     
:REM            Und natrlich fr etliche hilfreiche Hinweise. :-)         
:REM                                                                       
:REM  Kompatibilitt: UKAW ab v2.75             (Client)                   
:REM                  Windows 9x/ME, 2000/NT/XP (Betriebssystem/Shell)     
:REM                                                                       
:REM ͹
:REM                                                                       
:REM  Installation dieses Programms:                                       
:REM  ==============================                                       
:REM                                                                       
:REM  In einer RFC/Client-Serverbox unter Edit/Boxen/Edit/Client diese     
:REM  Batchdatei mit $CLPATH (Client-Verzeichnis und $CONFIG (Boxname ohne 
:REM  Dateierweiterung) als Parameter eintragen (mit <F2> kann auch ein    
:REM  entsprechend vorbereiteter Eintrag ausgewhlt und ggf. abgendert    
:REM  werden). Der Parameter /M ist optional und bewirkt die Anzeige eines 
:REM  POP3/SMTP/NNTP-Auswahlmens (sehr ntzlich!), mit /M2 bis /M5 kann   
:REM  die Menauswahl, die nach Ablauf eines Timeouts automatisch ausge-   
:REM  fhrt werden soll, definiert werden. Der Parameter /S bewirkt die    
:REM  Anzeige eines weiteren Mens, in dem eine Auswahl aus allen auf dem  
:REM  System eingerichteten DF-Netzwerk-Verbindungen getroffen werden     
:REM  kann.                                                                
:REM                                                                       
:REM  Bitte auch die brigen Hinweise in der Online-Hilfe, den Dateien     
:REM  INSTALL.TXT, UKAW.CFG (Konfigurationsdatei fr UKAW) und in dieser   
:REM  Batchdatei selbst (direkt unterhalb dieses Textes) beachten!         
:REM                                                                       
:REM ͼ
:REM
@echo off
goto BEGIN
:REM
:REM 
:GETMAIL
:REM
:REM                    Ŀ
:REM                                                    
:REM                      NACHRICHTEN HOLEN UND SENDEN  
:REM                                                    
:REM                    Ĵ
:REM                                                    
:REM                      Achtung! Dieser Programmteil  
:REM                      wird *nicht* zu Beginn ausge- 
:REM                      fhrt. Er wurde nur deshalb   
:REM                      an den Anfang der Batch ge-   
:REM                      stellt, weil in diesem Teil   
:REM                      Ergnzungen des Benutzers     
:REM                      zulssig (aber nicht erfor-   
:REM                      derlich) sind.                
:REM                                                    
:REM                    
:REM
:REM Ŀ
:REM  Aufruf der externen UKAW-Clients - Abfrage mehrerer Server
:REM 
:REM  Der Aufrufbefehl fr den Netcall der in XP ausgewhlten Box lautet
:REM  fr jeden Thread jeweils:
:REM 
:REM             <client> <Boxname>.BFG /<Option>
:REM 
:REM  Beispiel:  e-mail.exe %PAR2%.BFG /NoSmtp
:REM             (Die Variable %PAR2% enthlt dabei den Boxnamen)
:REM 
:REM  Diese Zeilen drfen nicht gendert oder gelscht werden!
:REM 
:REM  Die Servernamen, Envelope-Adressen, Benutzernamen, Paworte und Ports
:REM  werden zur Laufzeit von UKAW.BAT aus der Box-Konfiguration von XP, die
:REM  brigen Client-Einstellungen aus der Datei <Boxname>.CFG im UKAW-Ver-
:REM  zeichnis ausgelesen und gemeinsam in die Datei <Boxname>.BFG im UKAW-
:REM  Verzeichnis geschrieben. Aus dieser Datei lesen dann die UKAW-Clients
:REM  ihre Einstellungen aus.
:REM 
:REM  In dieser Batchdatei sind daher keinerlei benutzer- oder installa-
:REM  tionsspezifische Anpassungen erforderlich!
:REM 
:REM  Es *knnen* jedoch im Zusammenhang mit der Abfrage mehrerer POP3-
:REM  Server Ergnzungen vorgenommen werden, obwohl dies auch (und viel
:REM  komfortabler) in XP selbst konfiguriert werden kann. Zur Erluterung,
:REM  wo die Unterschiede beider Mglichkeiten liegen:
:REM 
:REM  In der Box-Konfiguration in XP knnen mehrere POP3-Server, Envelope-
:REM  Adressen, Ports und (sofern erforderlich) Benutzernamen und Paworte
:REM  durch Leerzeichen getrennt hintereinander eingegeben werden.
:REM 
:REM  Diese werden dann von UKAW automatisch hintereinander abgearbeitet.
:REM  Dabei ist jedoch zu bercksichtigen, da XP automatisch angelegten
:REM  Usern immer die Serverbox zuweist, fr die gerade der Netcall durch-
:REM  gefhrt wird.
:REM 
:REM  Da dies nicht immer wnschenswert ist, *kann* es daher sinnvoll sein,
:REM  die Abfrage mehrerer POP3-Server nicht durch zustzliche Server-
:REM  Eintrge in XP, sondern alternativ durch Hinzufgen von Kommandozeilen
:REM  in dieser Batchdatei zu realisieren und dem UKAW-Client dabei jeweils
:REM  einen anderen <Boxname> als Parameter zu bergeben. Die <Boxname>.BFG
:REM  mu manuell im Client-Verzeichnis angelegt werden und *smtliche*
:REM  Einstellungen enthalten (also auch alle Serverangaben, die sonst aus
:REM  der XP-Konfiguration ausgelesen wrden). Als Grundlage hierfr kann
:REM  die diesem Client-Kit beiliegende Datei BOXNAME.BFG verwendet werden
:REM  (*nicht* eine der eigentlichen Konfigurationsdateien UKAW.CFG,
:REM  UKAD.CFG oder UKAX.CFG!).
:REM 
:REM  In dieser Datei sind die entsprechenden Eintrge vorzunehmen (gem
:REM  den Erluterungen z.B. in UKAW.CFG). Wichtig dabei ist, da das Spool-
:REM  Verzeichnis ("Pop3Spool=") auf einen Wert gesetzt wird, der dem Spool-
:REM  Verzeichnis einer in XP eingerichteten RFC/Client-Serverbox ent-
:REM  spricht. Das Spool-Verzeichnis liegt bei RFC/Client-Boxen immer auf
:REM  <Laufwerk>:\<XP-Verzeichnis>\SPOOL\<Boxname>. Die eingegangenen Nach-
:REM  richten werden dann in diesem Verzeichnis abgelegt, aber erst dann in
:REM  XP eingelesen, wenn von XP aus ein Netcall fr diese Serverbox durch-
:REM  gefhrt wird. Es ist sinnvoll, die Datei BOXNAME.BFG in den Dateinamen
:REM  umzubenennen, der der Box-Konfigurationsdatei im XP-Verzeichnis ent-
:REM  spricht, deren Nachrichten beim Netcall fr eine andere Serverbox mit
:REM  bertragen (empfangen) werden sollen.
:REM 
:REM  Beispiel:  CrossPoint sei in C:\XP installiert
:REM 
:REM             Das Client-Verzeichnis sei C:\XP\UKAW
:REM 
:REM             Bei *jedem* Netcall (egal welcher Serverbox) sollen die
:REM              POP3-Nachrichten der in XP eingerichteten Serverbox
:REM              "Testbox" mit abgeholt und in deren box-spezifischen
:REM              Spool-Verzeichnis abgelegt werden.
:REM 
:REM  Vorgehen:  POP3-spezifische Eintrge in BOXNAME.BFG vornehmen, dabei
:REM              hinter den Bezeichner "Client-Spool=" den Wert
:REM              "C:\XP\SPOOL\TESTBOX\" (ohne Anfhrungsstriche und mit
:REM              abschlieendem Backslash!) eintragen.
:REM 
:REM             BOXNAME.BFG in TESTBOX.BFG umbenennen und ins Verzeichnis
:REM              C:\XP\UKAW kopieren.
:REM 
:REM             In dieser Batchdatei direkt unterhalb der Kommandozeile
:REM              "e-mail.exe %PAR2%.BFG /NoSmtp" (unterhalb der Sprungmarke
:REM              ":POP3") folgenden Befehl eintragen:
:REM 
:REM              e-mail.exe TESTBOX.BFG /NoSmtp
:REM 
:REM  Das klingt aufwendig (und ist es auch), aber damit ist gewhrleistet,
:REM  da man mehrere POP3-Server mit einem Netcall abfragen kann und (im
:REM  Unterschied zu der Lsung, mehrere Server hintereinander in XP einzu-
:REM  tragen) dennoch den von XP automatisch angelegten Usern die korrekte
:REM  Serverbox zugewiesen wird. Welches dieser beiden Verfahren verwendet
:REM  wird, liegt letztendlich in der Entscheidung des Benutzers.
:REM 
:REM  Dasselbe Verfahren kann analog auch auf die Abfrage von News-Servern
:REM  (NNTP) angewendet werden, wobei hier natrlich die NNTP-spezifischen
:REM  Eintrge in BOXNAME.BFG anzupassen sind. Alternativ knnen dem Aufruf
:REM  von E-NEWS.EXE auch mehrere <Boxname>.BFG als Parameter bergeben
:REM  werden, jedoch besteht dann hinsichtlich der Zuweisung von Serverboxen
:REM  bei von XP automatisch angelegten Brettern dasselbe Problem wie schon
:REM  fr die Abfrage mehrerer POP3-Server beschrieben.
:REM 
:REM  Fr SMTP macht eine Abfrage mehrerer Server derzeit keinen Sinn, weil
:REM  OpenXP die ausgehenden Nachrichten anderer XP-Serverboxen (noch) nicht
:REM  zum Versand bereitstellt.
:REM 
:REM  Hinweis: Das oben beschriebene Verfahren gilt nur vorlufig, denn das
:REM  gesamte Konzept des "Multiserverbetriebs" von UKAW ist hinsichtlich
:REM  der Zuweisung von Serverboxen an von XP automatisch angelegte User
:REM  oder Bretter (Newsgroups) leider nicht ausgereift.
:REM 
:REM  Es wird daher langfristig eine Lsung in OpenXP v3.40 und in diesem
:REM  Client-Kit implementiert werden, die den Konfigurationsaufwand fr die
:REM  Abfrage mehrerer Server bei einem Netcall auf ein Minimum reduziert
:REM  und dabei gleichzeitig sicherstellt, da *alle* Nachrichten nach einem
:REM  Netcall eingelesen werden, dabei automatisch angelegten Usern und/oder
:REM  Brettern aber dennoch die korrekte Serverbox zugewiesen wird. Diese
:REM  Lsung wird dann auch fr alle Protokolle (POP3, SMTP, NNTP) funktio-
:REM  nieren, und es werden auch Nachrichten anderer Serverboxen *gesendet*
:REM  werden knnen.
:REM 
:REM  Noch ein technischer Hinweis - diese Batchdatei besitzt zum Aufruf der
:REM  Clients einige Sprungmarken:
:REM 
:REM  :P-S-N    = Holen/Senden von Mail und News mit E-AGENT.EXE
:REM  :POP3SMTP = Holen/Senden von Mail mit E-MAIL.EXE oder E-AGENT.EXE
:REM  :POP3     = nur Holen von Mail mit E-MAIL.EXE oder E-AGENT.EXE
:REM  :SMTP     = nur Senden von Mail mit E-MAIL.EXE oder E-AGENT.EXE
:REM  :NNTP     = Holen und Senden von News mit E-NEWS.EXE oder E-AGENT.EXE
:REM 
:REM  Die nach diesen Sprungmarken stehenden Aufrufe werden in Abhngigkeit
:REM  davon ausgefhrt, welche Auswahl der Benutzer im Netcall-Auswahlmen
:REM  getroffen hat (fr Aufruf des Mens UKAW.BAT mit /M oder /M2 bis /M5
:REM  als erstem Parameter starten). Wenn in XP der entsprechende Server-
:REM  und/oder Port-Eintrag fehlen sollte, wird die entsprechende Routine
:REM  automatisch bersprungen.
:REM 
:REM  Bitte daher die 'if not "%$~$POP3%"==' und 'if not "%S%"=='-Befehls-
:REM  abfragen etc. direkt hinter jeder dieser Sprungmarken ebenfalls
:REM  nicht ndern oder lschen, da ansonsten die Funktionalitt dieser
:REM  Batchdatei sabotiert wird!
:REM 
:REM
:REM 
:REM
:REM Ŀ
:REM  Wenn E-TIME.EXE vorhanden, aktuelle Uhrzeit holen und aktualisieren.
:REM 
:REM
if not exist e-time.exe goto P-S-N
if exist ..\netcall.all goto P-S-N
:REM  Uni Erlangen #0 (131.188.1.40)
e-time.exe ntps1-0.uni-erlangen.de 
:REM  Uni Erlangen #1 (131.188.1.45)
:REM e-time.exe ntps1-1.uni-erlangen.de
:REM  Uni Erlangen #2 (131.188.1.31)
:REM e-time.exe ntps1-2.uni-erlangen.de
:REM  TU Berlin (131.149.l8.50)
:REM e-time.exe ntps1-0.cs.tu-berlin.de
:REM  Uni Osnabrck (131.173.17.11)
:REM e-time.exe ntps1-1.rz.uni-osnabrueck.de
:REM
:REM Ŀ
:REM  Wenn Menauswahl=1 und alle Server-Angaben komplett und E-AGENT.EXE
:REM  vorhanden, E-AGENT (statt E-MAIL/E-NEWS) starten.
:REM 
:P-S-N
for %%v in (%$~$POP3%,%$~$SMTP%,%$~$NNTP%) do if not "%%v"=="0" goto POP3SMTP
if not "%S%"=="1" goto POP3SMTP
if not exist e-agent.exe goto POP3SMTP
call $~$cls.bat
e-agent.exe %PAR2%
goto HANGUP
:REM
:REM 
:POP3SMTP
if not "%$~$POP3%"=="0" goto SMTP
if not "%S%"=="1" if not "%S%"=="2" goto POP3
call $~$cls.bat
if not exist e-mail.exe goto P-S-AGNT
e-mail.exe %PAR2%.BFG
goto NNTP
:P-S-AGNT
e-agent.exe %PAR2% /NoNntp
goto NNTP
:REM
:REM 
:POP3
if not "%S%"=="4" goto SMTP
call $~$cls.bat
if not exist e-mail.exe goto P-AGNT
e-mail.exe %PAR2%.BFG /NoSmtp
goto POP3-NXT
:P-AGNT
e-agent.exe %PAR2% /NoSmtp /NoNntp
:POP3-NXT
:REM
:REM  Ab hier knnen weitere POP3-Server angesprochen werden - Syntax:
:REM  e-mail.exe <Boxname>.BFG /NoSmtp
:REM  Beispiel:
:REM
:REM call $~$cls.bat
:REM e-mail.exe TESTBOX.BFG /NoSmtp
:REM
goto NNTP
:REM
:REM 
:SMTP
if not "%$~$SMTP%"=="0" goto NNTP
if not "%S%"=="5" goto NNTP
call $~$cls.bat
if not exist e-mail.exe goto S-AGNT
e-mail.exe %PAR2%.BFG /NoPop3
goto NNTP
:S-AGNT
e-agent.exe %PAR2% /NoPop3 /NoNntp
:REM
:REM 
:NNTP
if not "%$~$NNTP%"=="0" goto HANGUP
if not "%S%"=="1" if not "%S%"=="3" goto HANGUP
call $~$cls.bat
if not exist e-news.exe goto N-AGNT
e-news.exe %PAR2%
goto NNTP-NXT
:N-AGNT
e-agent.exe %PAR2% /NoPop3 /NoSmtp
:NNTP-NXT
:REM
:REM  Ab hier knnen weitere NNTP-Server angesprochen werden - Syntax:
:REM  e-news.exe <Boxname>.BFG
:REM  Beispiel:
:REM
:REM call $~$cls.bat
:REM e-news.exe TESTBOX
:REM
:REM 
:REM
goto HANGUP
:REM
:REM 
:REM
:REM       ͻ
:REM                                                                
:REM         AB HIER SOLLTEN NUR NOCH NDERUNGEN AN DER BATCHDATEI  
:REM         VORGENOMMEN WERDEN, WENN *UNBEDINGT* ERFORDERLICH UND  
:REM         WENN DERJENIGE *GENAU* WEISS, WAS ER TUT!!             
:REM                                                                
:REM         Im Zweifel bitte an den Autor der Batchdatei wenden.   
:REM                                                                
:REM       ͼ
:REM
:REM 
:BEGIN
:REM                 ͻ
:REM                                                       
:REM                   FEHLERBEHANDLUNG BEI PROGRAMMSTART  
:REM                     UND AUFBEREITUNG DER PARAMETER    
:REM                                                       
:REM                 ͼ
:REM
:REM Ŀ
:REM  Auf Existenz von CLNT-CFG.EXE prfen und ggf. abbrechen;
:REM  ansonsten $DO.COM (enthlt Batch-Tools) aus CLNT-CFG.EXE extrahieren.
:REM  Danach auf Existenz von $DO.COM prfen und ggf. abbrechen.
:REM 
if not exist clnt-cfg.exe goto NOCFGEXE
clnt-cfg.exe /extract:$do.com /q
if not exist $do.com goto NODOCOM
:REM Ŀ
:REM  Aktuelles Laufwerk und Verzeichnis (= Laufwerk und Pfad von XP)
:REM  ermitteln und in Variablen ablegen.
:REM 
$do varset XP-PATH=full of . > $~$XPATH.BAT
call $~$xpath.bat
$do varset XP-DRV=drive of %XP-PATH% > $~$XPDRV.BAT
$do varset XP-DIR=-drive of %XP-PATH% > $~$XPDIR.BAT
call $~$xpdrv.bat
call $~$xpdir.bat
set XP-PATH=
:REM Ŀ
:REM  Dialog-Wartezeit definieren (Standard=10 Sek., Blinde=60 Sek.,
:REM  Netcall/Alle=1 Sek.)
:REM 
set DLGPAUSE=1
for %%f in (all,end) do if exist netcall.%%f goto CHK-XP
set DLGPAUSE=10
if not exist xpoint.cfg goto CHK-XP
$do varget Blindensupport from XPOINT.CFG|$do xgrep -y "Blindensupport=J" > nul
if not errorlevel 1 set DLGPAUSE=60
:CHK-XP
:REM Ŀ
:REM  Auf XP-Verzeichnis prfen (anhand der Existenz bestimmter Dateien)
:REM  und ggf. abbrechen.
:REM 
set NOXP=
set ERROR=
if not exist xp.exe set NOXP=%NOXP%  XP.EXE
if not exist xp.ovr set NOXP=%NOXP%  XP.OVR
if not exist xp-?.res set NOXP=%NOXP%  XP-?.RES
if not exist xpoint.cfg set NOXP=%NOXP%  XPOINT.CFG
if "%NOXP%"=="" goto PAR0
set ERROR=NOXP
goto ERRTOP
:PAR0
:REM Ŀ
:REM  Variablen fr Menparameter (%M%) und Menauswahl (%S%) zurcksetzen.
:REM  aus dem Namen der Batch (%0) evtl. Anfhrungszeichen entfernen, in
:REM  Grobuchstaben wandeln, ggf. Endung .BAT ergnzen und in %PAR0%
:REM  speichern, auf Angabe des Menparameters "/M[1-5]" prfen, ggf.
:REM  sinnvollen Defaultwert setzen und Parameter verschieben ("shiften")
:REM  sowie entsprechenden Wert in Hilfsvariable %M% speichern.
:REM 
set M=
:REM Ŀ
:REM  Hilfsvariable %S% mit "1" initialisieren (fr den Fall, da
:REM  Parameter "/M" nicht angegeben wurde und daher %S% auch nicht durch
:REM  die Menauswahl gesetzt werden kann).
:REM 
set S=1
:REM Ŀ
:REM  Hier noch Erluterung fr Funktionsweise einfgen.
:REM 
$do qecho "%0"CRLF > $~$PAR0
type $~$par0|$do lmod set PAR0=[$1U] > $~$PAR0.BAT
call $~$par0.bat
$do varset EXT=ext of %PAR0% > $~$EXT.BAT
call $~$ext.bat
if "%EXT%"=="" set PAR0=%PAR0%.BAT
:REM  Menparameter "/M[1-5]" abfragen
$do qecho "%1"|$do xgrep -y "/m[1-5]?$" > nul
if errorlevel 1 goto CHK-DUN
:REM  Parameter "/M[1-5]" angegeben
if not "%1"=="/m" if not "%1"=="/M" goto USER-DEF
:REM  Parameter "/M" angegeben => Auto-Default
set M=1
goto CHK-DUN
:USER-DEF
:REM  Parameter "/M[1-5]" angegeben => Ziffer in Variable %M% speichern
$do qecho "%1"|$do lmod set M=[3,1] > $~$M.BAT
call $~$m.bat
:CHK-DUN
:REM  Variable fr DUN-Men setzen (DUN=DialUp Network)
set $~$DUNSL=0
if not "%M%"=="" shift
if not "%1"=="/s" if not "%1"=="/S" goto CHK-PARA
set $~$DUNSL=1
shift
:CHK-PARA
:REM Ŀ
:REM  Aus Parametern %1 und %2 Anfhrungszeichen und den Wert bis zum
:REM  ersten Leerzeichen rausfiltern (wegen der mglichen Angabe von LFNs
:REM  und der unterschiedlichen Behandlung von Anfhrungszeichen in DOS 5/6
:REM  und DOS 7.x ff.) und in die Variablen %PAR1% und %PAR2% schreiben.
:REM  Auf vollstndige Parameter, korrekte Parameter-Reihenfolge sowie
:REM  Existenz des Client-Verzeichnisses und der <Boxname>.BFG (Makros
:REM  $CLPATH und $CONFIG im Client-Aufruf von OpenXP) im XP-Verzeichnis
:REM  prfen und ggf. abbrechen.
:REM 
if not "%1"=="" goto PARAMS
set ERROR=NILPARA
goto ERRTOP

:PARAMS
:REM  Parameter aufbereiten und in Variablen schreiben
set PAR=%1
if not "%2"=="" goto PARALOOP
goto PARSE
:REM
:PARALOOP
shift
set PAR=%PAR% %1
if "%2"=="" goto PARSE
goto PARALOOP
:REM
:PARSE
$do qecho "%PAR%"CRLF > $~$PAR
type $~$par|$do lmod [$1U][+][$2U]|$do lmod /L* /N1 /S"" set PAR[#]=[$1] > $~$PAR.BAT
call $~$par.bat
set PAR=

:REM  Parameter-Variablen prfen
set $~$DIR1=0
set $~$DIR2=0
if not "%PAR1%"=="" if "%PAR2%"=="" goto ONEPARA
if not "%PAR1%"=="" if not "%PAR2%"=="" goto TWOPARA
set ERROR=NILPARA
goto ERRTOP
:ONEPARA
:REM  Prfung auf Verzeichnis-Existenz mittels VARSET und XGREP; mag komisch
:REM  aussehen, funktioniert dafr aber unter allen Umgebungen (DOS5-WinXP).
:REM  Wenn Verzeichnis existiert, wird %$~$DIR1% bzw. %$~$DIR2% auf ungleich
:REM  "0" gesetzt.
$do varset $~$DIR1=dirs %PAR1%.|$do xgrep -y "$~$DIR1=0" > nul
if errorlevel 1 set $~$DIR1=1
if not "%$~$DIR1%"=="0" set ERROR=NOBOX1
if not "%ERROR%"=="" goto ERRTOP
if "%$~$DIR1%"=="0" if exist %PAR1%.BFG set ERROR=NOCLDIR1
if "%ERROR%"=="" set ERROR=1NILEXST
goto ERRTOP
:TWOPARA
$do varset $~$DIR1=dirs %PAR1%.|$do xgrep -y "$~$DIR1=0" > nul
if errorlevel 1 set $~$DIR1=1
if not "%$~$DIR1%"=="0" if exist %PAR2%.BFG goto COPY-CFG
if not "%$~$DIR1%"=="0" if not exist %PAR2%.BFG set ERROR=NOBOX2
if not "%ERROR%"=="" goto ERRTOP
if "%$~$DIR1%"=="0" if exist %PAR2%.BFG set ERROR=NOCLDIR2
if not "%ERROR%"=="" goto ERRTOP
$do varset $~$DIR2=dirs %PAR2%.|$do xgrep -y "$~$DIR2=0" > nul
if errorlevel 1 set $~$DIR2=1
if not "%$~$DIR2%"=="0" if exist %PAR1%.BFG set ERROR=PARASWAP
if "%ERROR%"=="" set ERROR=2NILEXST
goto ERRTOP
:COPY-CFG
:REM Ŀ
:REM  Parameter sind OK (Client-Verzeichnis existiert, Box existiert).
:REM  Jetzt hngen wir an das Client-Verzeichnis einen Backslash an, falls
:REM  er nicht angegeben wurde (wichtig fr die folgenden Anweisungen).
:REM 
$do qecho "%PAR1%"|$do xgrep "\\$" > nul
if errorlevel 1 set PAR1=%PAR1%\
:REM Ŀ
:REM  UKAX.CFG, UKAW.CFG oder UKAD.CFG nach <Boxname>.CFG kopieren, wenn
:REM  nicht vorhanden. Dadurch kann eine einzige CFG-Datei fr alle Boxen
:REM  und UKA*-Clients gemeinsam verwendet werden. <Boxname>.CFG wird
:REM  nach dem Netcall automatisch gelscht, wenn sie nicht vorhanden war.
:REM  Sollte der Rechner oder XP whrend des Netcalls abgestrzt sein,
:REM  wird anhand der Semaphore <Boxname>.CPY beim nchsten Netcall der
:REM  vorherige Zustand wiederhergestellt. 
:REM 
if not exist %PAR1%%PAR2%.CPY if exist %PAR1%%PAR2%.CFG goto CHK-UKAW
for %%f in (cpy,cfg) do if exist %PAR1%%PAR2%.cfg del %PAR1%%PAR2%.%%f
:REM  Ich wei, die nchsten drei Zeilen kann man eleganter mit einer
:REM  for-in-do-Schleife lsen, gibt aber bei Verzeichnissen mit 8 Buchstaben
:REM  Probleme mit der Lnge der Kommandozeile unter DOS-Versionen bis 6.22.
if exist %PAR1%ukax.cfg copy %PAR1%ukax.cfg %PAR1%%PAR2%.CFG > nul
if exist %PAR1%ukaw.cfg if not exist %PAR1%%PAR2%.CFG copy %PAR1%ukaw.cfg %PAR1%%PAR2%.CFG > nul
if exist %PAR1%ukad.cfg if not exist %PAR1%%PAR2%.CFG copy %PAR1%ukad.cfg %PAR1%%PAR2%.CFG > nul
if not exist %PAR1%%PAR2%.cfg goto CHK-UKAW
$do qecho > %PAR1%%PAR2%.CPY
:CHK-UKAW
:REM Ŀ
:REM  Auf Existenz der erforderlichen Dateien im Client-Verzeichnis prfen
:REM  und ggf. abbrechen.
:REM 
set NOUKAW=
if not exist %PAR1%%PAR2%.CFG set NOUKAW=%NOUKAW%  %PAR2%.CFG
:REM  Wenn kein Eintrag bei D/B/E/Zugang existiert und Parameter /S nicht
:REM  angegeben wurde, dann darf auch WDIAL.EXE ruhig fehlen
:REM  (=> lokaler Netcall)
set $~$DUN=1
$do varget Client-DialUp from %PAR2%.BFG|$do xgrep -y "Client-DialUp=$" > nul
if not errorlevel 1 if not "%$~$DUNSL%"=="1" set $~$DUN=0
if not exist %PAR1%wdial.exe if not "%$~$DUN%"=="0" set NOUKAW=%NOUKAW%  WDIAL.EXE
if not "%NOUKAW%"=="" goto CHK-CLNT
if exist %PAR1%e-agent.exe goto NETCALL
if exist %PAR1%e-mail.exe if exist %PAR1%e-news.exe goto NETCALL
:CHK-CLNT
:REM  Wenn E-AGENT vorhanden ist, brauchen wir auf E-MAIL und E-NEWS nicht
:REM  mehr zu prfen
if exist %PAR1%e-agent.exe goto CLNT-END
if not exist %PAR1%e-mail.exe set NOUKAW=%NOUKAW%  E-MAIL.EXE
if not exist %PAR1%e-news.exe set NOUKAW=%NOUKAW%  E-NEWS.EXE
:REM  Wenn weder E-MAIL noch E-NEWS fehlen, fhren wir E-AGENT in der
:REM  Anzeige der fehlenden Dateien nicht auf
$do qecho "%NOUKAW%"|$do xgrep -y "e-....\.exe" > nul
if not errorlevel 1 set NOUKAW=%NOUKAW%  (E-AGENT.EXE)
:CLNT-END
set ERROR=NOUKAW
goto ERRTOP
:REM 
:NETCALL
:REM                              ͻ
:REM                                         
:REM                                NETCALL  
:REM                                         
:REM                              ͼ
:REM
if "%M%"=="" goto CLNT-ENV
:REM
:REM Ŀ
:REM  Wir prfen auf ausgehende Mail und passen den Default fr die Men-
:REM  Auswahl ggf. entsprechend an (wenn nichts zu versenden ist, brauchen
:REM  wir den entsprechenden Thread auch nicht zu starten).
:REM 
:REM
:REM  Mail zu versenden? Dann direkt Netcall-Men aufrufen, ansonsten
:REM  Menparameter auf sinnvollen Wert setzen.
if exist .\spool\%PAR2%\m????.out goto MENU
if "%M%"=="2" set M=4
if "%M%"=="5" set M=6
:REM 
:MENU
if exist wbat.in1 copy wbat.in1 WBAT.INI > nul
$do qecho ""
$do wbat menu +%PAR0%:SELECT #%M%,%DLGPAUSE% > $~$MENU.BAT
call $~$menu.bat
set WBAT=
set S=%?%
set ?=
if "%S%"=="100" goto ENDE
if "%S%"=="" set S=1
goto CLNT-ENV
:REM 
:SELECT
 Netcall bei %PAR2%

[ (&1)   Mail und News holen/senden  (POP3/SMTP/NNTP)]

[ (&2)   Mail holen/senden           (POP3/SMTP)     ]
[ (&3)   News holen/senden           (NNTP)          ]

[ (&4)   Mail holen                  (POP3)          ]
[ (&5)   Mail senden                 (SMTP)          ]

[?<Esc>  Netcall abbrechen&                           ]

 Bitte gewnschte Funktion auswhlen... (%DLGPAUSE% Sek.)
:
:REM 
:CLNT-ENV
:REM Ŀ
:REM  ClearScreen-Routine in Abhngigkeit von "ScreenLines=" in XPOINT.CFG
:REM  in temporre Batchdatei $~$CLS.BAT schreiben. $~$CLS.BAT lscht nur
:REM  das Brett- bzw. User-Fenster von XP und setzt den Cursor in Zeile 5,
:REM  Spalte 0, so da der Netcall optisch vollstndig innerhalb der
:REM  XP-Oberflche abluft.
:REM 
$do varget ScreenLines from XPOINT.CFG > $~$LINES.BAT
call $~$lines.bat
if "%SCREENLINES%"=="" set SCREENLINES=25
$do varset $~$LINES=(%SCREENLINES%-5) > $~$LINES.BAT
call $~$lines.bat
$do qecho "..\$do ascreen=" 027 "[4;0H" CRLF > %PAR1%$~$CLS.BAT
$do qecho "..\$do wbat fill 4,1 (%$~$LINES%) (white on black) "" """CRLF >> %PAR1%$~$CLS.BAT
$do qecho "..\$do ascreen=" 027 "[5;0H" CRLF >> %PAR1%$~$CLS.BAT
set SCREENLINES=
:REM Ŀ
:REM  XP.EXE ins Client-Verzeichnis kopieren und XP.OVR als 0-Byte-Datei 
:REM  anlegen (UKAW v2.75 prft auf beide Dateien).
:REM 
copy xp.exe %PAR1%. > nul
$do qecho > %PAR1%XP.OVR
:REM Ŀ
:REM  XPOINT.COL ins Client-Verzeichnis kopieren (wird von UKAW
:REM  ausgewertet).
:REM 
if exist xpoint.col copy xpoint.col %PAR1%. > nul
:REM Ŀ
:REM  XPOINT.CFG ins Client-Verzeichnis kopieren (wird von UKAW teilweise
:REM  ausgewertet).
:REM  ACHTUNG: Der Eintrag "LogDir=" wird in einem spteren Schritt von
:REM  CLNT-CFG.EXE fr UKAW v2.75 vorbergehend auf das Client-Verzeichnis
:REM  gesetzt, um die Datei XPCLIENT.LOG erzeugen und somit einen Netz-
:REM  anrufbericht schreiben zu knnen. UKAW v2.75 erzeugt im OpenXP-Modus
:REM  zwar selbst eine Logdatei XPCLIENT.LOG, diese ist jedoch unvollstn-
:REM  dig, weil sie kein Log von WDIAL.EXE enthlt. Also lassen wir die
:REM  (vollstndige) Logdatei UKAW.LOG ins Client-Verzeichnis schreiben,
:REM  benennen sie am Ende des Netcalls in XPCLIENT.LOG um, hngen sie an
:REM  die UKAW.LOG im Log-Verzeichnis an und XP hngt XPCLIENT.LOG dann
:REM  nach Beendigung des Netcalls automatisch an seinen Netzanrufbericht
:REM  an.
:REM 
copy xpoint.cfg %PAR1%. > nul
:REM Ŀ
:REM  Erstellen der Client-Konfiguration unter Bercksichtigung der
:REM  XP-Konfiguration (XPOINT.CFG), der Box-Konfiguration (<Boxname>.BFG
:REM  im XP-Verzeichnis) sowie der client-spezifischen Einstellungen in
:REM  <Boxname>.CFG im Client-Verzeichnis.
:REM 
clnt-cfg.exe /ukaw /p:%PAR1% /b:%PAR2% /q
:REM  Hier noch Errorlevel-Behandlung fr CLNT-CFG.EXE einbauen!!!
:REM  if errorlevel irgendwas goto FEHLER
:REM Ŀ
:REM  Ab jetzt sind wir im Client-Verzeichnis - dies ist beim Aufruf
:REM  von im XP-Verzeichnis liegenden Programmen ($DO.COM, CLNT-CFG.EXE)
:REM  zu beachten!
:REM 
cd %PAR1%.
:REM Ŀ
:REM  Prfung auf Server- und Porteintrge in der <Boxname>.BFG im XP-Ver-
:REM  zeichnis in Abhngigkeit von der Auswahl, die der Anwender im
:REM  POP3/SMTP/NNTP-Men getroffen hat, sowie ggf. Generieren und
:REM  Ausfhren eines entsprechenden Fehlerdialogs.
:REM 
call $~$srvr.bat

:SRVR-CHK
:REM  Prfung der wahrscheinlichen Flle (alle erforderlichen Servereintrge
:REM  vorhanden).
if "%S%"=="1" if "%$~$POP3%"=="0" if "%$~$SMTP%"=="0" if "%$~$NNTP%"=="0" goto DIAL
if "%S%"=="2" if "%$~$POP3%"=="0" if "%$~$SMTP%"=="0" goto DIAL
if "%S%"=="3" if "%$~$NNTP%"=="0" goto DIAL
if "%S%"=="4" if "%$~$POP3%"=="0" goto DIAL
if "%S%"=="5" if "%$~$SMTP%"=="0" goto DIAL
:REM  Prfung der nicht so wahrscheinlichen Flle (alle erforderlichen
:REM  Servereintrge leer).
if "%S%"=="1" if not "%$~$POP3%"=="0" if not "%$~$SMTP%"=="0" if not "%$~$NNTP%"=="0" goto SRVR-CNL
if "%S%"=="2" if not "%$~$POP3%"=="0" if not "%$~$SMTP%"=="0" goto SRVR-CNL
if "%S%"=="3" if not "%$~$NNTP%"=="0" goto SRVR-CNL
if "%S%"=="4" if not "%$~$POP3%"=="0" goto SRVR-CNL
if "%S%"=="5" if not "%$~$SMTP%"=="0" goto SRVR-CNL
:REM  Es ist nur ein Teil der erforderlichen Servereintrge vorhanden.
set SVERRDLG=Netcall bei den brigen Servern durchfhren?
set SVERROPT=[  Ja  ]   [?  Nein  ]
set SVERR100=ENDE
set SVERR0=DIAL
goto POP3SRVR

:SRVR-CNL
set SVERRDLG=Netcall wird abgebrochen...
set SVERROPT=[  OK  ]
set SVERR100=ENDE
set SVERR0=ENDE

:POP3SRVR
if not "%S%"=="1" if not "%S%"=="2" if not "%S%"=="4" goto SMTPSRVR
if "%$~$POP3%"=="" set $~$POP3=0
goto POP3-%$~$POP3%
:POP3-0
set POP3DLG=
goto SMTPSRVR
:POP3-1
set POP3DLG=Kein POP3-Server bei Box %PAR2%
goto SMTPSRVR
:POP3-2
set POP3DLG=Kein POP3-Port bei Box %PAR2%
goto SMTPSRVR
:POP3-3
set POP3DLG=Kein POP3-Server und -Port bei Box %PAR2%

:SMTPSRVR
if not "%S%"=="1" if not "%S%"=="2" if not "%S%"=="5" goto NNTPSRVR
if "%$~$SMTP%"=="" set $~$SMTP=0
goto SMTP-%$~$SMTP%
:SMTP-0
set SMTPDLG=
goto NNTPSRVR
:SMTP-1
set SMTPDLG=Kein SMTP-Server bei Box %PAR2%
goto NNTPSRVR
:SMTP-2
set SMTPDLG=Kein SMTP-Port bei Box %PAR2%
goto NNTPSRVR
:SMTP-3
set SMTPDLG=Kein SMTP-Server und -Port bei Box %PAR2%

:NNTPSRVR
if not "%S%"=="1" if not "%S%"=="3" goto SDLGTOP
if "%$~$NNTP%"=="" set $~$NNTP=0
goto NNTP-%$~$NNTP%
:NNTP-0
set NNTPDLG=
goto SDLGTOP
:NNTP-1
set NNTPDLG=Kein NNTP-Server bei Box %PAR2%
goto SDLGTOP
:NNTP-2
set NNTPDLG=Kein NNTP-Port bei Box %PAR2%
goto SDLGTOP
:NNTP-3
set NNTPDLG=Kein NNTP-Server und -Port bei Box %PAR2%

:SDLGTOP
:REM  Bei fehlenden Serverangaben Fehlerdialog generieren und aufrufen
..\$do qecho ":SRVRERR"CRLF > $~$SVERR.TXT
..\$do qecho CRLF >> $~$SVERR.TXT
goto SVERRDLG
:SDLGEND
..\$do qecho CRLF >> $~$SVERR.TXT
..\$do qecho "  %SVERRDLG%  ^"CRLF >> $~$SVERR.TXT
..\$do qecho CRLF CRLF >> $~$SVERR.TXT
..\$do qecho "  %SVERROPT%  (%DLGPAUSE% Sek.)  ^"CRLF >> $~$SVERR.TXT
..\$do qecho ":"CRLF >> $~$SVERR.TXT
:SDLGEXEC
if exist ..\wbat.in2 copy ..\wbat.in2 ..\WBAT.INI > nul
..\$do qecho ""
..\$do wbat box @$~$SVERR.TXT:SRVRERR #1,%DLGPAUSE%
if errorlevel 100 goto %SVERR100%
if errorlevel 0 goto %SVERR0%

:SVERRDLG
:POP3-DLG
if "%POP3DLG%"=="" goto SMTP-DLG
..\$do qecho "  %POP3DLG% eingetragen!  ^"CRLF >> $~$SVERR.TXT
:SMTP-DLG
if "%SMTPDLG%"=="" goto NNTP-DLG
..\$do qecho "  %SMTPDLG% eingetragen!  ^"CRLF >> $~$SVERR.TXT
:NNTP-DLG
if "%NNTPDLG%"=="" goto SDLGEND
..\$do qecho "  %NNTPDLG% eingetragen!  ^"CRLF >> $~$SVERR.TXT
goto SDLGEND

:DIAL
:REM Ŀ
:REM  Anwahl...
:REM 
set UKAWLOG=XP
:REM  Lokaler Netcall?
if "%$~$DUN%"=="0" goto GETMAIL
:REM  Wenn NETCALL.ALL oder NETCALL.END im XP-Verzeichnis *und* WDial.Dat im
:REM  Client-Verzeichnis existieren, dann
:REM  a) ist dies ein Netcall/Alle, und dann
:REM  b) ist dies die zweite Box, die einen Netcall durchfhrt, und dann
:REM     wurde
:REM  c) die Verbindung von WDIAL.EXE beim vorherigen Netcall hergestellt.
:REM  In diesem Fall benennen wir WDial.Dat in WDial.Yes um, damit sie nicht
:REM  von WDIAL.EXE beim Aufruf gelscht wird (was der Fall wre, wenn WDIAL
:REM  eine bestehende Verbindung erkennt) und somit fr den weiteren Ablauf
:REM  des Netcall/Alle-Zyklus zur Verfgung steht. Wir knnten auch WDIAL
:REM  gar nicht aufrufen, aber dann htten wir keinen vollstndigen
:REM  Netzanrufbericht ("A connection to '...' exists already!").
for %%f in (all,end) do if exist ..\netcall.%%f if exist wdial.dat ren wdial.dat WDial.Yes
call $~$cls.bat
if "%$~$DUNSL%"=="1" goto DIAL-SEL
wdial.exe /DIAL %PAR2%
goto DIAL-CHK
:DIAL-SEL
wdial.exe /DIAL %PAR2% /SELECT
:DIAL-CHK
:REM Ŀ
:REM  Nachrichten holen und senden (Aufruf der externen Clients).
:REM  Die Routine GETMAIL befindet sich ganz am Anfang dieser Batchdatei.
:REM 
if not errorlevel 2 goto GETMAIL
:REM Ŀ
:REM  Bei Verbindungsfehler Meldung ausgeben und Netcall abbrechen.
:REM 
if errorlevel 2 set ERROR=NOCONN
if errorlevel 3 set ERROR=NODUN
goto ERRTOP
:HANGUP
:REM Ŀ
:REM  Abwahl...
:REM 
if "%$~$DUN%"=="0" goto SORT-BL
if exist ..\netcall.all if not exist ..\netcall.end goto SORT-BL
:REM  Wenn NETCALL.END im XP-Verzeichnis und WDial.Yes (umbenannt von
:REM  WDial.Dat) im Client-Verzeichnis existiert, dann
:REM  a) ist dies die letzte Box in einem Netcall/Alle-Zyklus mehrerer
:REM     Boxen, und dann wurde
:REM  b) die Verbindung von WDIAL.EXE beim Netcall der ersten Box im
:REM     Netcall/Alle-Zyklus hergestellt.
:REM  In diesem Fall lschen wir eine evtl. existierende WDial.Already, die
:REM  beim Aufruf von WDIAL.EXE beim Netcall der letzten Box angelegt wurde.
:REM  WDIAL.EXE wrde sonst flschlicherweise die Verbindung nicht trennen,
:REM  weil es denken wrde, die Verbindung sei nicht von WDIAL.EXE aufgebaut
:REM  worden, sondern habe schon zu Beginn des Netcall/Alle bestanden.
:REM  Den Sonderfall eines Netcall/Alle mit nur einer Box brauchen wir nicht
:REM  zu behandeln, weil dann keine umbenannte WDial.Yes existieren kann,
:REM  sondern nur die originale WDial.Dat.
if exist ..\netcall.end if exist wdial.yes if exist wdial.already del wdial.already
:REM  Nur zur Sicherheit Ausgangszustand wiederherstellen, wer wei...
if exist ..\netcall.end if exist wdial.yes ren wdial.yes WDial.Dat
call $~$cls.bat
wdial.exe /HANGUP %PAR2%
:REM Ŀ
:REM  Listen der vorhandenen (*.BL) und der bestellten (*.RC) Newsgroups
:REM  mit korrektem Zeilenabschlu versehen und anschlieend sortieren.
:REM 
:SORT-BL
if not exist %PAR2%.BL goto SORT-RC
echo.
echo Sortiere Liste der vorhandenen Newsgroups von Box: %PAR2%
if exist $~$.?bl del $~$.?bl
..\$do crlf /t /e < %PAR2%.BL > $~$.$BL
..\$do rpsort /q /a /b /d /n /z $~$.$BL $~$.~BL
if errorlevel 1 goto SORT-RC
if exist $~$.~bl del %PAR2%.bl
if not exist %PAR2%.bl ren $~$.~bl %PAR2%.BL
:SORT-RC
if not exist %PAR2%.RC goto ENDE
echo.
echo Sortiere Liste der bestellten Newsgroups von Box: %PAR2%
if exist $~$.?rc del $~$.?rc
..\$do crlf /t /e < %PAR2%.RC > $~$.$RC
..\$do rpsort /q /a /b /d /n /z $~$.$RC $~$.~RC
if errorlevel 1 goto ENDE
if exist $~$.~rc del %PAR2%.rc
if not exist %PAR2%.rc ren $~$.~rc %PAR2%.RC
goto ENDE
:REM 
:REM
:REM                         ͻ
:REM                                              
:REM                           ABBRUCH-MELDUNGEN  
:REM                                              
:REM                         ͼ
:REM
:NOCFGEXE
echo   Ŀ
echo                                                                       
echo     Fehler: CLNT-CFG.EXE nicht vorhanden - Netcall wird abgebrochen!  
echo                                                                       
echo     Bitte CLNT-CFG.EXE ins XP-Verzeichnis kopieren!                   
echo                                                                       
echo   
echo 
goto ENDE
:REM 
:NODOCOM
echo   Ŀ
echo                                                                  
echo     Fehler: $DO.COM nicht vorhanden - Netcall wird abgebrochen!  
echo                                                                  
echo     Bitte Bugreport per eMail an dev@openxp.de oder an           
echo     my@openxp.de senden!                                         
echo                                                                  
echo   
echo 
goto ENDE
:REM 
:ERRTOP
%XP-DRV%
cd %XP-DIR%
$do qecho ":ERROR"CRLF > $~$ERROR.TXT
$do qecho CRLF >> $~$ERROR.TXT
goto %ERROR%
:ERREND
$do qecho CRLF CRLF >> $~$ERROR.TXT
$do qecho "  [  OK  ]  (%DLGPAUSE% Sek.)  ^"CRLF >> $~$ERROR.TXT
$do qecho ":"CRLF >> $~$ERROR.TXT
:ERREXEC
if exist wbat.in2 copy wbat.in2 WBAT.INI > nul
$do qecho ""
$do wbat box +$~$ERROR.TXT:ERROR #1,%DLGPAUSE%
goto ENDE
:REM 
:NILPARA
$do qecho "  Fehler: Parameter <Client-Pfad> und <Boxname> fehlen!  ^"CRLF >> $~$ERROR.TXT
goto SYNTXERR
:REM 
:NOBOX1
$do qecho "  Fehler: Parameter <Boxname> fehlt!  ^"CRLF >> $~$ERROR.TXT
goto SYNTXERR
:REM 
:NOCLDIR1
$do qecho "  Fehler: Parameter <Client-Pfad> fehlt!  ^"CRLF >> $~$ERROR.TXT
goto SYNTXERR
:REM 
:1NILEXST
$do qecho "  Fehler: Client-Pfad oder Boxname ""%PAR1%"" existiert nicht!  ^"CRLF >> $~$ERROR.TXT
goto SYNTXERR
:REM 
:NOBOX2
$do qecho "  Fehler: Boxname ""%PAR2%"" existiert nicht!  ^"CRLF >> $~$ERROR.TXT
goto SYNTXERR
:REM 
:NOCLDIR2
$do qecho "  Fehler: Client-Pfad ""%PAR1%"" existiert nicht!  ^"CRLF >> $~$ERROR.TXT
goto SYNTXERR
:REM 
:PARASWAP
$do qecho "  Fehler: Parameter-Reihenfolge <Client-Pfad> und <Boxname> vertauscht!  ^"CRLF >> $~$ERROR.TXT
$do qecho "          (%PAR0% %PAR1% %PAR2%)  ^"CRLF >> $~$ERROR.TXT
goto SYNTXERR
:REM 
:2NILEXST
$do qecho "  Fehler: Client-Pfad ""%PAR1%"" existiert nicht!  ^"CRLF >> $~$ERROR.TXT
$do qecho "  Fehler: Boxname ""%PAR2%"" existiert nicht!  ^"CRLF >> $~$ERROR.TXT
goto SYNTXERR
:REM 
:NOXP
$do qecho "  Fehler: UKAW wurde nicht aus XP-Verzeichnis gestartet  ^"CRLF >> $~$ERROR.TXT
$do qecho "          oder die XP-Installation ist unvollstndig!  ^"CRLF >> $~$ERROR.TXT
$do qecho CRLF >> $~$ERROR.TXT
$do qecho "  Folgende Dateien konnten nicht gefunden werden:  ^"CRLF >> $~$ERROR.TXT
$do qecho CRLF >> $~$ERROR.TXT
$do qecho "%NOXP%"CRLF >> $~$ERROR.TXT
goto ERREND
:REM 
:SYNTXERR
$do qecho CRLF >> $~$ERROR.TXT
$do qecho "  Syntax: UKAW [[/M[[1..5]] [[/S] <Client-Pfad> <Boxname>  ^"CRLF >> $~$ERROR.TXT
$do qecho CRLF >> $~$ERROR.TXT
$do qecho "          [[/M | /M1]     Menauswahl POP3/SMTP/NNTP anzeigen  ^"CRLF >> $~$ERROR.TXT
$do qecho "          [[/M2../M5]     dto., Standardauswahl ndern  ^"CRLF >> $~$ERROR.TXT
$do qecho "          [[/S]           Zustzlich Auswahl der DF-Netzwerk-  ^"CRLF >> $~$ERROR.TXT
$do qecho "                         Verbindungen anzeigen  ^"CRLF >> $~$ERROR.TXT
$do qecho "          <Client-Pfad>  Relativer Pfad zum Client-Verzeichnis  ^"CRLF >> $~$ERROR.TXT
$do qecho "                         direkt unterhalb des XP-Verzeichnisses  ^"CRLF >> $~$ERROR.TXT
$do qecho "          <Boxname>      Name der Box-Konfigurationsdatei (BFG)  ^"CRLF >> $~$ERROR.TXT
$do qecho "                         (*ohne* die Dateierweiterung ""BFG""!)  ^"CRLF >> $~$ERROR.TXT
$do qecho CRLF >> $~$ERROR.TXT
$do qecho "          Bei Angabe von langen Dateinamen (LFNs) wird jeweils  ^"CRLF >> $~$ERROR.TXT
$do qecho "          nur der Wert bis zum ersten Leerzeichen bercksichtigt!  ^"CRLF >> $~$ERROR.TXT
goto ERREND
:REM 
:NOUKAW
$do qecho "  Fehler: UKAW ist nicht oder nicht vollstndig installiert!  ^"CRLF >> $~$ERROR.TXT
$do qecho CRLF >> $~$ERROR.TXT
$do qecho "  Folgende Dateien konnten nicht gefunden werden:  ^"CRLF >> $~$ERROR.TXT
$do qecho CRLF >> $~$ERROR.TXT
$do qecho "%NOUKAW%"CRLF >> $~$ERROR.TXT
$do qecho CRLF >> $~$ERROR.TXT
$do qecho "  Bitte die fehlenden Dateien ins Unterverzeichnis %PAR1% kopieren.  ^"CRLF >> $~$ERROR.TXT
goto ERREND
:REM 
:NOCONN
$do qecho "  DF-Netzwerk-Verbindung konnte nicht hergestellt werden!  ^"CRLF >> $~$ERROR.TXT
goto ERREND
:REM 
:NODUN
$do qecho "  Angegebene DF-Netzwerk-Verbindung existiert nicht!  ^"CRLF >> $~$ERROR.TXT
$do qecho "  Bitte unter Edit/Boxen/Edit/Client/Zugang korrigieren!  ^"CRLF >> $~$ERROR.TXT
goto ERREND
:REM 
:ENDE
:REM                       ͻ
:REM                                                
:REM                         NETCALL-LOG + CLEANUP  
:REM                                                
:REM                       ͼ
:REM
if "%PAR1%"=="" goto RESET
if "%PAR2%"=="" goto RESET
if "%XP-DRV%"=="" goto RESET
if "%XP-DIR%"=="" goto RESET
%XP-DRV%
cd %XP-DIR%
if "%$~$DIR1%"=="0" goto CLEANUP
cd %PAR1%.
:REM Ŀ
:REM  Netcall-Log UKAW.LOG in XPCLIENT.LOG umbenennen (wird dann auto-
:REM  matisch in den XP-Netzanrufbericht geschrieben) und an UKAW.LOG im
:REM  XP-Logverzeichnis anhngen.
:REM 
if exist xpclient.log del xpclient.log
if not exist ukaw.log goto CLEANUP
ren ukaw.log XPCLIENT.LOG
..\$do varget LogDir from ..\XPOINT.CFG > $~$LGDIR.BAT
call $~$lgdir.bat
type xpclient.log >> %LOGDIR%UKAW.LOG

:CLEANUP
if not "%$~$DIR1%"=="0" cd..
:REM  Die folgende Prfung auf abschlieenden Backslash ist leider nochmal
:REM  erforderlich, weil es sein kann, da wir aus einer Fehlerroutine
:REM  kommen und die vorherige Prfung in :COPY-CFG noch nicht durchlaufen
:REM  haben. Wrde diese Prfung nicht stattfinden, knnten ungewollt Dateien
:REM  im XP-Verzeichnis gelscht werden!
$do qecho "%PAR1%"|$do xgrep "\\$" > nul
if errorlevel 1 set PAR1=%PAR1%\
for %%f in (%PAR1%$~$*.*,%PAR1%%PAR2%.bfg,%PAR1%%PAR2%.bfe) do if exist %%f del %%f
for %%f in (%PAR1%xp.exe,%PAR1%xp.ovr,%PAR1%xpoint.col,%PAR1%xpoint.cfg) do if exist %%f del %%f
for %%f in ($~$*.*) do if exist %%f del %%f
for %%f in ($do.com,wbat.in?) do if exist %%f del %%f
if not exist %PAR1%%PAR2%.cpy goto RESET
for %%f in (cpy,cfg) do if exist %PAR1%%PAR2%.cfg del %PAR1%%PAR2%.%%f

:RESET
for %%v in (M,S,$~$DUNSL,$~$DUN,XP-DRV,XP-DIR,LOGDIR,UKAWLOG) do set %%v=
for %%p in (PAR0,PAR1,PAR2) do set %%p=
for %%v in (NOXP,NOUKAW) do set %%v=
for %%v in ($~$DIR1,$~$DIR2,$~$LINES,DLGPAUSE,PAUSE,REDIALMAX,CONNMAX,DIALS,NEXTDIAL,CONNS) do set %%v=
for %%v in ($~$POP3,$~$SMTP,$~$NNTP,POP3DLG,SMTPDLG,NNTPDLG,SVERRDLG,SVERROPT,SVERR100,SVERR0) do set %%v=
set ERROR=

:REM 
